//+------------------------------------------------------------------+
//|                                                          MMR.mq4 |
//|                                  Based on a strategy by cmillion |
//|             EMA5+LWMA85 crossover with MACD and RSI confirmation |
//+------------------------------------------------------------------+
#property copyright "Copyright @ 2011, downspin"
#property link      "mg@downspin.de"


#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 DodgerBlue
#property indicator_color2 Green
#property indicator_color3 Red
#property indicator_width2 5
#property indicator_width3 5
#property indicator_level1 0
#property indicator_levelcolor DarkSlateGray

//
//
//
//
//

extern int    mac_fast_ma      = 12;
extern int    mac_slow_ma      = 26;
extern int    mac_signal       = 9;
extern int    rsi_period       = 14;
extern int    ema_period       = 5;
extern int    lwma_period      = 85;

extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsNotify     = true;
extern bool   alertsEmail      = true;
extern string soundFile        = "alert2.wav"; 

extern bool   ShowArrows       = false;
extern string arrowsIdentifier = "mmr Arrows";
extern double arrowsUpperGap   = 1.0;
extern double arrowsLowerGap   = 1.0;
extern color  arrowsUpColor    = LimeGreen;
extern color  arrowsDnColor    = Red;
extern color  arrowsUpCode     = 241;
extern color  arrowsDnCode     = 242;

//
//
//
//
//

double long1[];
double short1[];
double val[];
double trend[];
double atrend[];

//
//
//
//
//

int init()
{
  IndicatorBuffers(5);
  SetIndexBuffer(0,val);  
  SetIndexBuffer(1,long1); SetIndexStyle(1,DRAW_HISTOGRAM); 
  SetIndexBuffer(2,short1);SetIndexStyle(2,DRAW_HISTOGRAM); 
  SetIndexBuffer(3,trend);
  SetIndexBuffer(4,atrend);
  return(0);
}
int deinit()
{
   deleteArrows();
   
return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
            int limit = MathMin(Bars-counted_bars,Bars-1);
            
   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--) 
   {
     double ema  =  iMA(NULL,0,ema_period, 0,1,0,i);
     double lwma =  iMA(NULL,0,lwma_period,0,3,0,i);
     double rsi  =  iRSI(NULL,0,rsi_period,0,i);
     double mac  =  iMACD(NULL,0,mac_fast_ma,mac_slow_ma,mac_signal,0,0,i);
            mac  *= 3000;
            rsi  -= 50;
            val[i] = (ema-lwma)/(Point*10)+mac+rsi;
            long1[i]  = EMPTY_VALUE;
            short1[i] = EMPTY_VALUE;
            trend[i]  = 0;
            atrend[i] = atrend[i+1];
            if((ema>lwma)&&(rsi>10) &&(mac>0)) { trend[i] = 1; atrend[i] = 1; }
            if((ema<lwma)&&(rsi<-10)&&(mac<0)) { trend[i] =-1; atrend[i] =-1; }
            if (trend[i] == 1) long1[i] = val[i]-10;
            if (trend[i] ==-1) short1[i]= val[i]+10;  
            manageArrow(i);  
   }
manageAlerts();
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (atrend[whichBar] != atrend[whichBar+1])
      {
         if (atrend[whichBar] == 1) doAlert(whichBar,"Buy");
         if (atrend[whichBar] ==-1) doAlert(whichBar,"Sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," mmr ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," mmr " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(), Period(), " mmr "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      deleteArrow(Time[i]);
      if (atrend[i] != atrend[i+1])
      {
         if (atrend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode,false);
         if (atrend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDnCode, true);
      }
   }
}               

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}



